#include <stdio.h>
#include <iostream.h>

#define _1		'|'
#define _10     'n'
#define _100	'9'
#define _1000	'8'
#define _10000	'r'

char symbols[5]={_1,_10,_100,_1000,_10000};

int read_number()
{
   int c;
   int number=0;

   while((c=getchar())!='\n' && c!=EOF)
	  {
	  switch(c) {
		 case _1: number+=1; break;
		 case _10: number+=10; break;
		 case _100: number+=100; break;
		 case _1000: number+=1000; break;
		 case _10000: number+=10000; break;
		 }
	  }
   return number;
}

char* write_number(int n)
{
   int i,j,pos;
   static char str[100];

   j=0; pos=0;
   while(n>0)
	  {
	  i=n%10;
	  n/=10;
	  if(i>0)
		 {
		 while(i-- > 0) str[pos++]=symbols[j];
		 if(n>0) str[pos++]=' ';
		 }
	  j++;
	  }
   str[pos]='\0';
   return str;
}

void multiply(int a,int b)
{
   int i,ast;
   char s[100];
   int a2=a;

   i=1;
   while(i<=b)
	  {
	  if(b&i) ast=1; else ast=0;
	  sprintf(s,"%s %c",write_number(i),(ast!=0) ? '*' : ' ');
	  printf("%-40.40s%s\n",s,write_number(a2));
	  a2*=2;
	  i*=2;
	  }
   cout << "The solution is: " << write_number(a*b) << "\n";
}

void main()
{
   int a,b;

   while(!feof(stdin))
	  {
	  a=read_number();
	  b=read_number();
	  multiply(a,b);
	  }
}