#define MAX   1000
#include <stdio.h>
#include <string.h>

void RunMain()
{
  int num,den;
  int count,mods[MAX+1];
  int linelen;

  do {
	scanf("%i %i\n",&num,&den);
	if (den)
	{
		printf(".");
		memset(mods,0,sizeof(mods));
		mods[0]=1;
		count=0;
		linelen=1;
		while (!mods[num])
		{
			mods[num]=count+1;
			num*=10;
			if (num)
			{  if (linelen>=50)
				{
				  linelen=1;
				  printf("\n");
				} else
				  linelen++;
				printf("%i",num/den);
			}
			count++;
			num=num%den;
		}
		if (num)
		  printf("\nThe last %i digits repeat forever.\n",count-mods[num]+1);
		else
		  printf("\nThis expansion terminates.\n");
	}
  } while (num||den);
}

int main(int argc,char *argv[])
{
  int i,CasesN,N1,N2;

  if (argc > 1)
	 if (freopen(argv[1], "r", stdin) == NULL)
	  fprintf(stderr, "error redirecting stdin\n");

  if (argc > 2)
	 if (freopen(argv[2], "w", stdout) == NULL)
	  fprintf(stderr, "error redirecting stdout\n");

  RunMain();

  fclose(stdin);
  fclose(stdout);

  return 0;
}
